from decimal import Decimal

def main():
  # Uwaga implementacyjna: aby utrzymac pewnosc
  # ze liczby rzeczywiste beda poprawnie utrzymywane
  # w pamieci, mozemy uzyc biblioteki decimal
  # do otrzymywania zmiennych.
  (N, M, K) = tuple(map(Decimal, input().split()))

  # Dopóki mamy zasoby (pieniądze, ryby)
  # oraz możemy wykonywać operacje (K)
  while N > 0 and M > 0 and K > 0:
     # Liczymy ile ryb możemy kupić.
     moge_kupic = min(N, 2 * M)

     # Aktualizujemy ile pieniędzy mamy.
     N -= moge_kupic
     # Oraz ile ryb mamy po tej transakcji.
     M += moge_kupic / 2
     # Oraz zmniejszamy liczbę dostępnych operacji.
     K -= 1

  # Finalnie wypisujemy wynik w formacie z jedną
  # cyfrą po przecinku.
  print("{:.1f}".format(M))

if __name__ == "__main__":
    main()